package cn.iocoder.yudao.module.employee.service.employeeinfo;

import cn.iocoder.yudao.module.employee.controller.admin.employeeinfo.vo.*;
import cn.iocoder.yudao.module.employee.dal.dataobject.employeeinfo.EmployeeInfoDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import javax.validation.Valid;

/**
 * 员工信息 Service 接口
 *
 * @author 芋道源码
 */
public interface EmployeeInfoService {

    /**
     * 创建员工信息
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createInfo(@Valid EmployeeInfoSaveReqVO createReqVO);

    /**
     * 更新员工信息
     *
     * @param updateReqVO 更新信息
     */
    void updateInfo(@Valid EmployeeInfoSaveReqVO updateReqVO);

    /**
     * 删除员工信息
     *
     * @param id 编号
     */
    void deleteInfo(Long id);

    /**
     * 获得员工信息
     *
     * @param id 编号
     * @return 员工信息
     */
    EmployeeInfoDO getInfo(Long id);

    /**
     * 获得员工信息分页
     *
     * @param pageReqVO 分页查询
     * @return 员工信息分页
     */
    PageResult<EmployeeInfoDO> getInfoPage(EmployeeInfoPageReqVO pageReqVO);

    /**
     *
     *
     * @param userId
     * @param tenantId
     * @return
     */
    EmployeeInfoDO getInfoByUserIdAndTenantId(Long userId, Long tenantId);

    /**
     * 获得员工信息
     *
     * @param queryReqVO
     * @return
     */
    EmployeeInfoDO getInfo(@Valid EmployeeInfoQueryReqVO queryReqVO);


}